<template>
  <div class="sellReturn pagePadding">
    <div v-if="powers.some((i) => i == '001')">
      <ex-table
        v-loading="loading"
        :table="table"
        :data="tableData"
        :columns="columns"
        :page="pageInfo"
        :size="size"
        @page-curr-change="handlePageChange"
        @page-size-change="handleSizeChange"
        @selection="handleSelection"
        @screen-reset="
          pageInfo.curr = 1;
          parmValue.page = 1;
          searchList();
        "
        @screen-submit="
          pageInfo.curr = 1;
          parmValue.page = 1;
          searchList();
        "
      >
        <template #table-header="{}">
          <div style="width: 100%">
            <el-row style="padding: 0 0 0 80px">
              <el-col :span="3" style="width: 120px">
                <el-switch 
                  v-model="parmValue.use_type"
                  :active-value="usetypeOtions[1].value"
                  :inactive-value="usetypeOtions[0].value"
                  :active-text="usetypeOtions[1].label"
                  :inactive-text="usetypeOtions[0].label"
                  @change="
                    pageInfo.curr = 1;
                    parmValue.page = 1;
                    searchList();
                  "
                />
              </el-col>
              <el-col :span="4" style="width: 160px; padding: 0 0 0 10px">
                <el-select
                  :size="searchSize"
                  v-model="parmValue.order_source"
                  filterable
                  clearable
                  placeholder="订单来源"
                  style="width: 100%"
                  @change="
                    pageInfo.curr = 1;
                    parmValue.page = 1;
                    searchList();
                  "
                >
                  <el-option
                    v-for="item in xs_order_source_options"
                    :key="'orderstatus' + item.id"
                    :label="item.label"
                    :value="item.id"
                  />
                </el-select>
              </el-col>
              <el-col :span="4" style="width: 160px; padding: 0 0 0 10px">
                <el-select
                  :size="searchSize"
                  v-model="parmValue.order_type"
                  filterable
                  clearable
                  placeholder="商品类型"
                  style="width: 100%"
                  @change="
                    pageInfo.curr = 1;
                    parmValue.page = 1;
                    searchList();
                  "
                >
                  <el-option
                    v-for="item in xs_order_type_options"
                    :key="'orderstatus' + item.id"
                    :label="item.label"
                    :value="item.id"
                  />
                </el-select>
              </el-col>

              <el-col :span="4" style="width: 240px; padding: 0 0 0 10px">
                <search-supplier
                  :size="'mini'"
                  style="width: 100%"
                  :value="parmValue.supplierNo"
                  :disabled="false"
                  :placeholder="'供应商名称'"
                  :names="parmValue.supplierName"
                  :isDetail="true"
                  :noDisabled="true"
                  @searchChange="supplierChange"
                />
              </el-col>

              <el-col :span="3" style="width: 66px; float: right">
                <el-button
                  :size="searchSize"
                  type="primary"
                  style="float: right; margin-left: 5px"
                  @click="searchList"
                >
                  刷新
                </el-button>
              </el-col>
            </el-row>
            <el-row style="padding: 10px 0 0 0">
              <el-col :span="4" style="width: 200px">
                <el-select
                  style="width: 100%"
                  placeholder="状态"
                  size="mini"
                  clearable
                  v-model="parmValue.status"
                  @change="
                    pageInfo.curr = 1;
                    parmValue.page = 1;
                    searchList();
                  "
                >
                  <el-option label="待收货" value="1" />
                  <el-option label="已收货" value="2" />
                </el-select>
              </el-col>
              <el-col :span="8" style="width: 502px; padding: 0 0 0 10px">
                <el-input
                  placeholder="关键字"
                  size="mini"
                  v-model="queryValue"
                  @blur="
                    pageInfo.curr = 1;
                    parmValue.page = 1;
                    searchList();
                  "
                >
                  <template #prepend>
                    <el-select
                      style="width: 150px"
                      v-model="queryKey"
                      @change="
                        pageInfo.curr = 1;
                        parmValue.page = 1;
                        searchList();
                      "
                    >
                      <el-option value="returnCode" label="售后申请单编码" />
                      <el-option value="orderCode" label="订单编码" />
                      <el-option value="outChildCode" label="发货工单编码" />
                      <!-- <el-option value="return_wsm_code" label="退货仓库编码" /> -->
                    </el-select>
                  </template>
                  <el-button
                    slot="append"
                    icon="el-icon-search"
                    @click="
                      pageInfo.curr = 1;
                      parmValue.page = 1;
                      searchList();
                    "
                  ></el-button>
                </el-input>
              </el-col>
              <el-col :span="4" class="fr" style="width: 66px; padding: 0 0 0 10px">
                <el-button
                  type="warning"
                  class="fr"
                  :size="searchSize"
                  @click="restSearch"
                >
                  重置
                </el-button>
              </el-col>
            </el-row>
          </div>
        </template>
        <template #status="{ scope }">
          <el-tag
            :size="tablebtnSize"
            :type="scope.row.status == '0' ? 'warning' : ''"
            v-text="
              (statusOptions.find((item) => item.value == scope.row.status) || {})
                .label || '--'
            "
          ></el-tag>
        </template>

        <template #stcok_in="{scope}">{{
            scope.row.type === "1" ? scope.row.can_sell_num : scope.row.defective_num
        }}</template>

        <template #returnWsm="{ scope }">
          <el-popover placement="top" width="360" trigger="hover">
            <i class="el-icon-warning-outline" slot="reference"></i>
            <ul>
              <li><h3>退货仓库</h3></li>
              <li>
                <span>编号:</span><span>{{ scope.row.return_wsm_code }}</span>
              </li>
              <li>
                <span>名称:</span><span>{{ scope.row.return_wsm_name }}</span>
              </li>
              <li>
                <span>负责人:</span><span>{{ scope.row.return_contactor_name }}</span>
              </li>
              <li>
                <span>供应商编码:</span><span>{{ scope.row.return_supplierNo }}</span>
              </li>
              <li>
                <span>供应商名称:</span><span>{{ scope.row.return_supplierName }}</span>
              </li>
            </ul>
          </el-popover>
          <span>{{ scope.row.return_wsm_name }}</span>
        </template>

        <template #order_type="{ scope }">
          <el-tag size="mini">{{
            (xs_order_type_options.find(({ id }) => id === scope.row.order_type) || {})
              ?.label || "--"
          }}</el-tag>
        </template>

        <template #use_type="{ scope }">
          <el-tag size="mini">
            {{
              (usetypeOtions.find(({ value }) => value === scope.row.use_type) || {})
                .label || "---"
            }}
          </el-tag>
        </template>

        <template #stock_type="{ scope }">
          <el-tag :type="scope.row.type !== '1' ? 'warning' : ''" size="mini">{{
            scope.row.type === "1" ? "销售仓" : "次品仓"
          }}</el-tag>
        </template>

        <template #sendWsm="{ scope }">
          <el-popover placement="top" width="360" trigger="hover">
            <i class="el-icon-warning-outline" slot="reference"></i>
            <ul>
              <li><h3>退货仓库</h3></li>
              <li>
                <span>编号:</span><span>{{ scope.row.send_wsm_code }}</span>
              </li>
              <li>
                <span>名称:</span><span>{{ scope.row.send_wsm_name }}</span>
              </li>
              <li>
                <span>负责人:</span><span>{{ scope.row.send_contactor_name }}</span>
              </li>
              <li>
                <span>供应商编码:</span><span>{{ scope.row.send_supplierNo }}</span>
              </li>
              <li>
                <span>供应商名称:</span><span>{{ scope.row.send_supplierName }}</span>
              </li>
            </ul>
          </el-popover>
          <span>{{ scope.row.send_wsm_name }}</span>
        </template>

        <template #type="{ scope }">
          <el-tag size="mini">{{
            scope.row.type === "1" ? "未发货退货" : "售后申请"
          }}</el-tag>
        </template>

        <template #order_type="{ scope }">
          <el-tag
            :size="tablebtnSize"
            v-text="
              (
                xs_order_type_options.find((item) => item.id == scope.row.order_type) ||
                {}
              ).label || '--'
            "
          ></el-tag>
        </template>

        <template #order_source="{ scope }">
          <el-tag
            :size="tablebtnSize"
            v-text="
              (
                xs_order_source_options.find(
                  (item) => item.id == scope.row.order_source
                ) || {}
              ).label || '--'
            "
          ></el-tag>
        </template>

        <template #operation="{ scope }">
          <el-tooltip
            v-if="powers.some((i) => i == '007')"
            effect="dark"
            content="详情"
            placement="top"
          >
            <i
              class="el-icon-view tb-icon"
              @click="getRouter('returnGoodWorkOrderDetail', scope.row.id)"
            ></i>
          </el-tooltip>
        </template>
      </ex-table>
    </div>
    <div v-else>
      <no-auth></no-auth>
    </div>
  </div>
</template>
<script>
import mixinPage from "@/mixins/elPaginationHandle";
import resToken from "@/mixins/resToken";
import asyncRequest from "@/apis/service/sellOut/returnGoodWorkOrder";
import {
  xs_order_type_options,
  xs_order_source_options,
  usetypeOtions,
} from "@/assets/js/statusList";
import companyHelper from "@/mixins/companyHelper";
import urlConfig from "@/apis/url-config";
import { mapGetters } from "vuex";
import columns from "./columns";

export default {
  name: "sellReturn",
  mixins: [mixinPage, resToken, companyHelper],
  computed: {
    ...mapGetters(["tablebtnSize", "searchSize", "size"]),
    powers() {
      const tran =
        this.$store.getters.btnList.find(
          (item) => item.menu_route == "returnGoodWorkOrder"
        ) || {};
      const { action } = tran ?? {};
      return action ?? [];
    },
  },
  data() {
    return {
      xs_order_type_options,
      xs_order_source_options,
      fileUrl: urlConfig.baseURL,
      usetypeOtions,
      select: "outChildCode", //默认选择下拉框
      s_input: "", //搜索框内容
      select_list: [],
      supplierNo: [],
      sitem: null,
      // 状态
      statusOptions: [
        { value: "1", label: "待主流程收货" },
        { value: "2", label: "主流程已收货" },
      ],
      loading: false,
      showModel: false,
      isDetail: false,
      modelId: 0,
      parmValue: {
        supplierNo:"",
        supplierName:"",
        use_type: "1",
        type: "",
        order_type: "",
        returnCode: "",
        status: "",
        page: 1, // 页码
        size: 15, // 每页显示条数
        // order_type: "",
      },
      queryKey: "returnCode",
      queryValue: "",
      tableData: [],
      passwordModel: false,
      passwordModelId: 0,
      isPasswordDetail: false,
      // 表格 - 数据
      tableData: [],
      // 表格 - 参数
      table: {
        stripe: true,
        border: true,
        _defaultHeader_: ["setcol"],
      },
      // 表格 - 分页
      pageInfo: {
        size: 15,
        curr: 1,
        total: 0,
      },
      // 表格 - 列参数
      columns: columns,
    };
  },
  mounted() {
    const { back } = this.$route.query;
    if (back) {
      this.parmValue = JSON.parse(back);
      const { page, size } = this.parmValue;
      this.queryKey = this.parmValue.queryKey;
      this.queryValue = this.parmValue.queryValue;
      // this.parmValue.start = start || last_start;
      // this.parmValue.end = end || last_end;
      // if(this.parmValue.companyNo.length>0){
      //     this.customerCode = [this.parmValue.companyNo] ;
      // }

      this.pageInfo = {
        size: size,
        curr: page,
        total: 0,
      };
      //多选条件
      this.select = this.parmValue.select;
      // this.sselect = this.parmValue.sselect;
      this.s_input = this.parmValue.s_input;
    } else {
      this.select = "outChildCode";
      //  this.sselect = "创建时间"
    }
    this.searchList();
  },

  methods: {
    async supplierChange(e) {
      const { code, label } = e;
      this.parmValue.supplierNo = code ? [code] : [];
      this.parmValue.supplierName = label
      this.searchList();
    },
    customer_code_change(e) {
      if (e && e.code) {
        this.parmValue.customer_code = [e.code];
      } else {
        this.parmValue.customer_code = [];
      }
      this.searchList();
    },
    handleExport() {
      if (!this.loading) {
        this.loading = true;
        let httpType = `aplication/zip`;

        let model = JSON.parse(JSON.stringify(this.parmValue));
        delete model["s_input"];

        axios({
          method: "post",
          url: this.fileUrl + "/admin/child_export",
          responseType: "blob",
          data: {
            ...model,
            [this.select]: this.s_input,
            customer_code: Array.isArray(this.parmValue.customer_code)
              ? this.parmValue.customer_code[0]
              : this.parmValue.customer_code,
            needRela: true,
          },
          headers: {
            Accept: httpType,
          },
        })
          .then((res) => {
            if (res && res.status == 200 && res.data) {
              let url = window.URL.createObjectURL(
                new Blob([res.data], { type: httpType })
              );
              let link = document.createElement("a");
              link.style.display = "none";
              link.href = url;
              let excelName = "发货工单.zip";
              link.setAttribute("download", excelName);
              document.body.appendChild(link);
              link.click();
              link.remove();
              window.URL.revokeObjectURL(url); //释放掉blob对象
              this.$message.success(`导出成功！`);
              setTimeout(() => {
                this.loading = false;
              }, 500);
            } else {
              this.$message.error(res.data.message);
              setTimeout(() => {
                this.loading = false;
              }, 500);
            }
          })
          .catch((error) => {
            console.log(error);
            this.loading = false;
          });
      }
    },
    handleSelection(order) {
      const { list } = order;
      this.select_list = list;
    },
    getRouter(toRouter, queryId) {
      if (toRouter && queryId) {
        let model = {
          id: queryId,
        };

        //有多选框的条件
        this.parmValue.queryKey = this.queryKey;
        // this.parmValue.sselect = this.sselect ;
        this.parmValue.queryValue = this.queryValue;
        let routerModel = {
          options: JSON.parse(JSON.stringify(this.parmValue)),
          router: this.$route.path,
        };
        model.preModel = JSON.stringify(routerModel);

        this.routeGoto(toRouter, model);
      }
    },
    restSearch() {
      this.s_input = ""; //清除输入框内容
      this.select = "outChildCode"; //清除下拉框选中项

      this.parmValue = {
        use_type: "1",
        order_type: "1",
        company_name: "", //申请人部门
        good_code: "",
        returnCode: "", //销售退货code
        orderCode: "", //销售订单code
        apply_name: "", //申请人
        start: "",
        end: "",
        status: "", //节点状态
        page: 1, // 页码
        size: 15, // 每页显示条数
      };

      this.queryValue = "";

      // 表格 - 分页
      this.pageInfo = {
        size: 15,
        curr: 1,
        total: 0,
      };
      this.searchList();
    },

    openModal(id, isDetail, sitem) {
      this.showModel = true;
      this.modelId = id;
      this.isDetail = isDetail;
      this.sitem = sitem;
    },
    async deleteById(id, status) {
      await this.$confirm("确定要删除？", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(async () => {
          const model = {
            id: id,
            status: status + "" === "1" ? "0" : "1",
          };
          const res = await asyncRequest.status(model);
          if (res && res.code === 0) {
            this.$notify.success({
              title: "删除成功",
              message: "",
            });
            this.searchList();
          } else if (res && res.code >= 100 && res.code <= 104) {
            await this.logout();
          } else {
            this.$message.warning(res.message);
          }
        })
        .catch(() => {
          console.log("取消");
        });
    },
    async searchList() {
      if (
        (this.parmValue.start !== "" && this.parmValue.end === "") ||
        (this.parmValue.start === "" && this.parmValue.end !== "")
      ) {
        this.$message.warning("时间区间不完整！");
        return;
      }
      this.loading = true;

      let model = JSON.parse(JSON.stringify(this.parmValue));
      console.log(model)
      delete model["s_input"];
      // delete model['supplierNo']

      const res = await asyncRequest.list({
        ...model,
        is_authority: "1",
        [this.select]: this.s_input,
        [this.queryKey]: this.queryValue,
        companyNo: this.currentCompany,
        supplierNo: Array.isArray(model.supplierNo) ? model.supplierNo[0] : model.supplierNo,
        customer_code: Array.isArray(this.parmValue.customer_code)
          ? this.parmValue.customer_code[0]
          : this.parmValue.customer_code,
        noRelation: true,
      });

      if (res && res.code === 0 && res.data) {
        this.tableData = res.data.list;
        this.pageInfo.total = Number(res.data.count);
      } else if (res && res.code >= 100 && res.code <= 104) {
        await this.logout();
      } else {
        this.tableData = [];
        this.pageInfo.total = 0;
      }
      this.loading = false;
    },

    //物流公司查询
    async handleCompany(e) {
      console.log(e, "要求传快递简称，不传id"); //
      if (e && e.code) {
        this.parmValue.postCompany = [e.shortName];
        this.parmValue.page = 1;
      }
      await this.searchList();
    },

    company_idsearchChange(e) {
      const { code } = e;
      this.parmValue.companyNo = code || "";
      this.searchList();
    },

    // 时间
    async handleTime(e) {
      if (e.startTime !== "") {
        this.parmValue.start = e.startTime;
      } else {
        this.parmValue.start = "";
      }
      if (e.endTime !== "") {
        this.parmValue.end = e.endTime;
      } else {
        this.parmValue.end = "";
      }
      if (this.parmValue.start !== "" && this.parmValue.end !== "") {
        this.parmValue.page = 1;
        await this.searchList();
      }
    },
  },
};
</script>
<style lang="scss" scoped>
.sellReturn {
}
</style>
